diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java
index 13650edd3..f795cddc6 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java
@@ -9,34 +9,51 @@ import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
 import net.minecraft.core.world.generate.chunk.perlin.SurfaceGenerator;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.retro.ChunkDecoratorOverworldRetro;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.retro.SurfaceGeneratorOverworldRetro;
-import net.minecraft.core.world.noise.CombinedPerlinNoise;
-import net.minecraft.core.world.noise.LegacyNoiseType;
-import net.minecraft.core.world.noise.PerlinNoise;
+import net.minecraft.core.world.noise.*;
+import net.minecraft.core.world.noise.operator.Constant2D;
+import net.minecraft.core.world.noise.operator.Warp2D;
 import org.jetbrains.annotations.NotNull;
 
 public class ChunkGeneratorClassic
     extends ChunkGenerator {
-    private final @NotNull CombinedPerlinNoise combinedA;
-    private final @NotNull CombinedPerlinNoise combinedB;
-    private final @NotNull CombinedPerlinNoise combinedC;
-    private final @NotNull CombinedPerlinNoise combinedD;
-    private final @NotNull PerlinNoise octavesA;
-    private final @NotNull PerlinNoise octavesB;
+    private final @NotNull Warp2D<FractalNoise2D<ImprovedPerlinNoise>, FractalNoise2D<ImprovedPerlinNoise>, Constant2D> combinedA;
+    private final @NotNull Warp2D<FractalNoise2D<ImprovedPerlinNoise>, FractalNoise2D<ImprovedPerlinNoise>, Constant2D> combinedB;
+    private final @NotNull Warp2D<FractalNoise2D<ImprovedPerlinNoise>, FractalNoise2D<ImprovedPerlinNoise>, Constant2D> combinedC;
+    private final @NotNull Warp2D<FractalNoise2D<ImprovedPerlinNoise>, FractalNoise2D<ImprovedPerlinNoise>, Constant2D> combinedD;
+    private final @NotNull FractalNoise2D<ImprovedPerlinNoise> octavesA;
+    private final @NotNull FractalNoise2D<ImprovedPerlinNoise> octavesB;
 
     private final @NotNull SurfaceGenerator sg;
     private final @NotNull CavesLargeFeature cg;
 
     public ChunkGeneratorClassic(@NotNull World world) {
         super(world, new ChunkDecoratorOverworldRetro(world));
-        long seed = world.getRandomSeed();
 
-        this.combinedA = new CombinedPerlinNoise(new PerlinNoise(seed, 8, 0, LegacyNoiseType.ALPHA), new PerlinNoise(seed, 8, 8, LegacyNoiseType.ALPHA));
-        this.combinedB = new CombinedPerlinNoise(new PerlinNoise(seed, 8, 16, LegacyNoiseType.ALPHA), new PerlinNoise(seed, 8, 24, LegacyNoiseType.ALPHA));
-        this.combinedC = new CombinedPerlinNoise(new PerlinNoise(seed, 8, 32, LegacyNoiseType.ALPHA), new PerlinNoise(seed, 8, 40, LegacyNoiseType.ALPHA));
-        this.combinedD = new CombinedPerlinNoise(new PerlinNoise(seed, 8, 48, LegacyNoiseType.ALPHA), new PerlinNoise(seed, 8, 56, LegacyNoiseType.ALPHA));
-
-        this.octavesA = new PerlinNoise(seed, 6, 64, LegacyNoiseType.ALPHA);
-        this.octavesB = new PerlinNoise(seed, 8, 70, LegacyNoiseType.ALPHA);
+        final long seed = world.getRandomSeed();
+
+        this.combinedA = new Warp2D<>(
+            new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(seed, 8, 0, ImprovedPerlinNoise.LegacyNoiseType.ALPHA)),
+            new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(seed, 8, 8, ImprovedPerlinNoise.LegacyNoiseType.ALPHA)),
+            new Constant2D(0.0)
+        );
+        this.combinedB = new Warp2D<>(
+            new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(seed, 8, 16, ImprovedPerlinNoise.LegacyNoiseType.ALPHA)),
+            new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(seed, 8, 24, ImprovedPerlinNoise.LegacyNoiseType.ALPHA)),
+            new Constant2D(0.0)
+        );
+        this.combinedC = new Warp2D<>(
+            new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(seed, 8, 32, ImprovedPerlinNoise.LegacyNoiseType.ALPHA)),
+            new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(seed, 8, 40, ImprovedPerlinNoise.LegacyNoiseType.ALPHA)),
+            new Constant2D(0.0)
+        );
+        this.combinedD = new Warp2D<>(
+            new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(seed, 8, 48, ImprovedPerlinNoise.LegacyNoiseType.ALPHA)),
+            new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(seed, 8, 56, ImprovedPerlinNoise.LegacyNoiseType.ALPHA)),
+            new Constant2D(0.0)
+        );
+
+        this.octavesA = new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(seed, 8, 64, ImprovedPerlinNoise.LegacyNoiseType.ALPHA));
+        this.octavesB = new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(seed, 8, 70, ImprovedPerlinNoise.LegacyNoiseType.ALPHA));
 
         this.sg = new SurfaceGeneratorOverworldRetro(world);
         this.cg = new CavesLargeFeature();
@@ -56,8 +73,8 @@ public class ChunkGeneratorClassic
         // Raising..
         for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++) {
             for (int z = 0; z < Chunk.CHUNK_SIZE_Z; z++) {
-                final double noiseA = this.combinedA.get((chunkX * Chunk.CHUNK_SIZE_X + x) * mod, (chunkZ * Chunk.CHUNK_SIZE_Z + z) * mod) / 6.0D + -4;
-                double noiseB = this.combinedB.get((chunkX * Chunk.CHUNK_SIZE_X + x) * mod, (chunkZ * Chunk.CHUNK_SIZE_Z + z) * mod) / 5.0D + 10.0D + -4;
+                final double noiseA = this.combinedA.getValue((chunkX * Chunk.CHUNK_SIZE_X + x) * mod, (chunkZ * Chunk.CHUNK_SIZE_Z + z) * mod) / 6.0D + -4;
+                double noiseB = this.combinedB.getValue((chunkX * Chunk.CHUNK_SIZE_X + x) * mod, (chunkZ * Chunk.CHUNK_SIZE_Z + z) * mod) / 5.0D + 10.0D + -4;
                 if (this.octavesA.getValue(chunkX * Chunk.CHUNK_SIZE_X + x, chunkZ * Chunk.CHUNK_SIZE_Z + z) / 8.0D > 0.0D) {
                     noiseB = noiseA;
                 }
@@ -75,8 +92,8 @@ public class ChunkGeneratorClassic
         final int[] newHeightMap = heightMap;
         for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++) {
             for (int z = 0; z < Chunk.CHUNK_SIZE_Z; z++) {
-                final double val = this.combinedC.get((chunkX * Chunk.CHUNK_SIZE_X + x) << 1, (chunkZ * Chunk.CHUNK_SIZE_Z + z) << 1) / 8.0D;
-                final int val2 = this.combinedD.get((chunkX * Chunk.CHUNK_SIZE_X + x) << 1, (chunkZ * Chunk.CHUNK_SIZE_Z + z) << 1) > 0.0D ? 1 : 0;
+                final double val = this.combinedC.getValue((chunkX * Chunk.CHUNK_SIZE_X + x) << 1, (chunkZ * Chunk.CHUNK_SIZE_Z + z) << 1) / 8.0D;
+                final int val2 = this.combinedD.getValue((chunkX * Chunk.CHUNK_SIZE_X + x) << 1, (chunkZ * Chunk.CHUNK_SIZE_Z + z) << 1) > 0.0D ? 1 : 0;
                 if (val > 2.0D) {
                     final int newHeight = ((newHeightMap[x + z * Chunk.CHUNK_SIZE_X] - val2) / 2 << 1) + val2;
                     newHeightMap[x + z * Chunk.CHUNK_SIZE_X] = newHeight;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/LevelGenerator.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/LevelGenerator.java
index b217a406e..e28b80a18 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/LevelGenerator.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/indev/LevelGenerator.java
@@ -4,9 +4,9 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
-import net.minecraft.core.world.noise.CombinedPerlinNoise;
-import net.minecraft.core.world.noise.LegacyNoiseType;
-import net.minecraft.core.world.noise.PerlinNoise;
+import net.minecraft.core.world.noise.*;
+import net.minecraft.core.world.noise.operator.Constant2D;
+import net.minecraft.core.world.noise.operator.Warp2D;
 import org.jetbrains.annotations.NotNull;
 
 public final class LevelGenerator {
@@ -45,10 +45,18 @@ public final class LevelGenerator {
             } else {
                 // Raising phase
 //                System.out.println("Raising..");
-                CombinedPerlinNoise heightNoiseGeneratorA = new CombinedPerlinNoise(new PerlinNoise(seed, 8, 0, LegacyNoiseType.ALPHA), new PerlinNoise(seed, 8, 8, LegacyNoiseType.ALPHA));
-                CombinedPerlinNoise heightNoiseGeneratorB = new CombinedPerlinNoise(new PerlinNoise(seed, 8, 16, LegacyNoiseType.ALPHA), new PerlinNoise(seed, 8, 24, LegacyNoiseType.ALPHA));
-                PerlinNoise heightNoiseGeneratorSelector = new PerlinNoise(seed, 6, 32, LegacyNoiseType.ALPHA);
-                PerlinNoise edgeNoiseGenerator = new PerlinNoise(seed, 2, 38, LegacyNoiseType.ALPHA);
+                var heightNoiseGeneratorA = new Warp2D<>(
+                    new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(seed, 8, 0, ImprovedPerlinNoise.LegacyNoiseType.ALPHA)),
+                    new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(seed, 8, 8, ImprovedPerlinNoise.LegacyNoiseType.ALPHA)),
+                    new Constant2D(0.0)
+                );
+                var heightNoiseGeneratorB = new Warp2D<>(
+                    new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(seed, 8, 16, ImprovedPerlinNoise.LegacyNoiseType.ALPHA)),
+                    new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(seed, 8, 24, ImprovedPerlinNoise.LegacyNoiseType.ALPHA)),
+                    new Constant2D(0.0)
+                );
+                FractalNoise2D<ImprovedPerlinNoise> heightNoiseGeneratorSelector = new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(seed, 6, 32, ImprovedPerlinNoise.LegacyNoiseType.ALPHA));
+                FractalNoise2D<ImprovedPerlinNoise> edgeNoiseGenerator = new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(seed, 2, 38, ImprovedPerlinNoise.LegacyNoiseType.ALPHA));
 
                 for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++) {
                     double xDistanceFromCenter = Math.abs(((double) (x + xOffset) / ((double) this.sizeX - 1.0) - 0.5) * 2.0);
@@ -57,8 +65,8 @@ public final class LevelGenerator {
                         double zDistanceFromCenter = Math.abs(((double) (z + zOffset) / ((double) this.sizeZ - 1.0) - 0.5) * 2.0);
 
                         // Generate noise to use for height
-                        double heightNoiseA = heightNoiseGeneratorA.get((float) (x + xOffset) * 1.3F, (float) (z + zOffset) * 1.3F) / 6.0 + -4.0;
-                        double heightNoiseB = heightNoiseGeneratorB.get((float) (x + xOffset) * 1.3F, (float) (z + zOffset) * 1.3F) / 5.0 + 10.0 + -4.0;
+                        double heightNoiseA = heightNoiseGeneratorA.getValue((float) (x + xOffset) * 1.3F, (float) (z + zOffset) * 1.3F) / 6.0 + -4.0;
+                        double heightNoiseB = heightNoiseGeneratorB.getValue((float) (x + xOffset) * 1.3F, (float) (z + zOffset) * 1.3F) / 5.0 + 10.0 + -4.0;
                         double heightNoiseToUse = heightNoiseGeneratorSelector.getValue(x + xOffset, z + zOffset) / 8.0;
                         if (heightNoiseToUse > 0.0) {
                             heightNoiseB = heightNoiseA;
@@ -97,13 +105,21 @@ public final class LevelGenerator {
 
                 // Eroding phase
 //                System.out.println("Eroding..");
-                CombinedPerlinNoise erosionPowerNoiseGenerator = new CombinedPerlinNoise(new PerlinNoise(seed, 8, 40, LegacyNoiseType.ALPHA), new PerlinNoise(seed, 8, 48, LegacyNoiseType.ALPHA));
-                CombinedPerlinNoise erosionAmountNoiseGenerator = new CombinedPerlinNoise(new PerlinNoise(seed, 8, 56, LegacyNoiseType.ALPHA), new PerlinNoise(seed, 8, 64, LegacyNoiseType.ALPHA));
+                var erosionPowerNoiseGenerator = new Warp2D<>(
+                    new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(seed, 8, 40, ImprovedPerlinNoise.LegacyNoiseType.ALPHA)),
+                    new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(seed, 8, 48, ImprovedPerlinNoise.LegacyNoiseType.ALPHA)),
+                    new Constant2D(0.0)
+                );
+                var erosionAmountNoiseGenerator = new Warp2D<>(
+                    new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(seed, 8, 56, ImprovedPerlinNoise.LegacyNoiseType.ALPHA)),
+                    new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(seed, 8, 64, ImprovedPerlinNoise.LegacyNoiseType.ALPHA)),
+                    new Constant2D(0.0)
+                );
 
                 for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++) {
                     for (int z = 0; z < Chunk.CHUNK_SIZE_Z; z++) {
-                        double erosionPower = erosionPowerNoiseGenerator.get((x + xOffset) << 1, (z + zOffset) << 1) / 8.0;
-                        int erosionAmount = erosionAmountNoiseGenerator.get((x + xOffset) << 1, (z + zOffset) << 1) > 0.0 ? 1 : 0;
+                        double erosionPower = erosionPowerNoiseGenerator.getValue((x + xOffset) << 1, (z + zOffset) << 1) / 8.0;
+                        int erosionAmount = erosionAmountNoiseGenerator.getValue((x + xOffset) << 1, (z + zOffset) << 1) > 0.0 ? 1 : 0;
 
                         if (erosionPower > 2.0) {
                             int height = heightMap[x + z * Chunk.CHUNK_SIZE_X];
@@ -116,8 +132,8 @@ public final class LevelGenerator {
 
             // Soiling phase
 //            System.out.println("Soiling..");
-            PerlinNoise soilNoiseGenerator = new PerlinNoise(seed, 8, 72, LegacyNoiseType.ALPHA);
-            PerlinNoise floatingLayerNoiseGenerator = new PerlinNoise(seed, 8, 80, LegacyNoiseType.ALPHA);
+            FractalNoise2D<ImprovedPerlinNoise> soilNoiseGenerator = new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(seed, 8, 72, ImprovedPerlinNoise.LegacyNoiseType.ALPHA));
+            FractalNoise2D<ImprovedPerlinNoise> floatingLayerNoiseGenerator = new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(seed, 8, 80, ImprovedPerlinNoise.LegacyNoiseType.ALPHA));
 
             for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++) {
                 double xDistanceFromCenter = Math.abs(((double) (x + xOffset) / ((double) this.sizeX - 1.0) - 0.5) * 2.0);
@@ -168,8 +184,8 @@ public final class LevelGenerator {
 
             // Growing phase - no idea why it's called this because it's very clearly generating beaches
 //            System.out.println("Growing..");
-            PerlinNoise sandNoiseGenerator = new PerlinNoise(seed, 8, 88, LegacyNoiseType.ALPHA);
-            PerlinNoise gravelNoiseGenerator = new PerlinNoise(seed, 8, 96, LegacyNoiseType.ALPHA);
+            FractalNoise2D<ImprovedPerlinNoise> sandNoiseGenerator = new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(seed, 8, 88, ImprovedPerlinNoise.LegacyNoiseType.ALPHA));
+            FractalNoise2D<ImprovedPerlinNoise> gravelNoiseGenerator = new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(seed, 8, 96, ImprovedPerlinNoise.LegacyNoiseType.ALPHA));
             int beachHeight = waterLevel - 1;
             if (this.worldTheme == IndevWorldTheme.PARADISE) {
                 beachHeight += 2;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/drift/DensityGeneratorDrift.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/drift/DensityGeneratorDrift.java
index afb601249..00b03069e 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/drift/DensityGeneratorDrift.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/drift/DensityGeneratorDrift.java
@@ -3,27 +3,28 @@ package net.minecraft.core.world.generate.chunk.perlin.drift;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.perlin.DensityGenerator;
-import net.minecraft.core.world.noise.PerlinNoise;
+import net.minecraft.core.world.noise.FractalNoise3D;
+import net.minecraft.core.world.noise.ImprovedPerlinNoise;
 import org.jetbrains.annotations.NotNull;
 
 public class DensityGeneratorDrift
     implements DensityGenerator {
     private final @NotNull World world;
 
-    private final @NotNull PerlinNoise minLimitNoise;
-    private final @NotNull PerlinNoise maxLimitNoise;
-    private final @NotNull PerlinNoise mainNoise;
-//    private final PerlinNoise scaleNoise;
-//    private final PerlinNoise depthNoise;
+    private final @NotNull FractalNoise3D<ImprovedPerlinNoise> minLimitNoise;
+    private final @NotNull FractalNoise3D<ImprovedPerlinNoise> maxLimitNoise;
+    private final @NotNull FractalNoise3D<ImprovedPerlinNoise> mainNoise;
+//    private final FractalNoise2D<ImprovedPerlinNoise> scaleNoise;
+//    private final FractalNoise2D<ImprovedPerlinNoise> depthNoise;
 
     public DensityGeneratorDrift(@NotNull World world) {
         this.world = world;
 
-        this.minLimitNoise = new PerlinNoise(world.getRandomSeed(), 16, 0);
-        this.maxLimitNoise = new PerlinNoise(world.getRandomSeed(), 16, 16);
-        this.mainNoise = new PerlinNoise(world.getRandomSeed(), 8, 32);
-//        scaleNoise = new PerlinNoise(world.getRandomSeed(), 10, 48);
-//        depthNoise = new PerlinNoise(world.getRandomSeed(), 16, 58);
+        this.minLimitNoise = new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 16, 0));
+        this.maxLimitNoise = new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 16, 16));
+        this.mainNoise = new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 8, 32));
+//        this.scaleNoise = new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 10, 48));
+//        this.depthNoise = new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 16, 58));
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
index bbe327f77..f9a00f5d1 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
@@ -8,7 +8,10 @@ import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkDecorator;
 import net.minecraft.core.world.generate.feature.*;
-import net.minecraft.core.world.noise.PerlinNoise;
+import net.minecraft.core.world.noise.FractalNoise2D;
+import net.minecraft.core.world.noise.FractalNoise3D;
+import net.minecraft.core.world.noise.ImprovedPerlinNoise;
+import net.minecraft.core.world.noise.Noise2D;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
@@ -16,11 +19,11 @@ import java.util.Random;
 public class ChunkDecoratorNether
     implements ChunkDecorator {
     private final @NotNull World world;
-    private final @NotNull PerlinNoise crystalDensityNoise;
+    private final @NotNull Noise2D crystalDensityNoise;
 
     public ChunkDecoratorNether(@NotNull World world) {
         this.world = world;
-        this.crystalDensityNoise = new PerlinNoise(world.getRandomSeed(), 6, 74);
+        this.crystalDensityNoise = new FractalNoise2D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 6, 74));
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java
index c43c0e0e9..cf29fbf42 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java
@@ -7,14 +7,12 @@ import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.biome.provider.BiomeProviderNether;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.perlin.DensityGenerator;
-import net.minecraft.core.world.noise.PerlinNoise;
-import net.minecraft.core.world.noise.PerlinSimplexNoise;
+import net.minecraft.core.world.noise.*;
 import net.minecraft.core.world.type.WorldType;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.HashMap;
 import java.util.Map;
-import java.util.Random;
 
 public class DensityGeneratorNether
     implements DensityGenerator {
@@ -24,37 +22,36 @@ public class DensityGeneratorNether
 
     private final @NotNull World world;
 
-    private final @NotNull PerlinNoise minLimitNoise;
-    private final @NotNull PerlinNoise maxLimitNoise;
-    private final @NotNull PerlinNoise mainNoise;
-    private final @NotNull PerlinNoise scaleNoise;
-    private final @NotNull PerlinNoise depthNoise;
+    private final @NotNull Noise3D minLimitNoise;
+    private final @NotNull Noise3D maxLimitNoise;
+    private final @NotNull Noise3D mainNoise;
+    private final @NotNull Noise2D scaleNoise;
+    private final @NotNull Noise2D depthNoise;
 
-    private final @NotNull PerlinSimplexNoise poolNoiseOver;
-    private final @NotNull PerlinSimplexNoise poolNoiseUnder;
+    private final @NotNull FractalNoise2D<?> poolNoiseOver;
+    private final @NotNull FractalNoise2D<?> poolNoiseUnder;
 
-    private final @NotNull PerlinSimplexNoise ravineNoise2;
+    private final @NotNull FractalNoise2D<?> ravineNoise2;
 
-    private final @NotNull PerlinSimplexNoise islandNoise;
+    private final @NotNull FractalNoise2D<?> islandNoise;
 
     private final @NotNull Map<@NotNull Biome, @NotNull BiomeDensityGenerator> densityGeneratorMap = new HashMap<>();
 
     public DensityGeneratorNether(World world) {
         this.world = world;
 
-        this.minLimitNoise = new PerlinNoise(world.getRandomSeed(), 16, 0);
-        this.maxLimitNoise = new PerlinNoise(world.getRandomSeed(), 16, 16);
-        this.mainNoise = new PerlinNoise(world.getRandomSeed(), 8, 32);
-        this.scaleNoise = new PerlinNoise(world.getRandomSeed(), 10, 48);
-        this.depthNoise = new PerlinNoise(world.getRandomSeed(), 16, 58);
+        this.minLimitNoise = new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 16, 0));
+        this.maxLimitNoise = new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 16, 16));
+        this.mainNoise = new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 8, 32));
+        this.scaleNoise = new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 10, 48));
+        this.depthNoise = new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 16, 58));
 
-        Random rand = new Random(world.getRandomSeed());
+        final long seed = world.getRandomSeed();
 
-        this.islandNoise = new PerlinSimplexNoise(rand, 6);
-        this.ravineNoise2 = new PerlinSimplexNoise(rand, 4);
-
-        this.poolNoiseOver = new PerlinSimplexNoise(rand, 4);
-        this.poolNoiseUnder = new PerlinSimplexNoise(rand, 1);
+        this.islandNoise = new FractalNoise3D<>(SimplexNoise.genOctaves(seed, 6, 0));
+        this.ravineNoise2 = new FractalNoise3D<>(SimplexNoise.genOctaves(seed, 4, 6));
+        this.poolNoiseOver = new FractalNoise3D<>(SimplexNoise.genOctaves(seed, 4, 10));
+        this.poolNoiseUnder = new FractalNoise3D<>(SimplexNoise.genOctaves(seed, 1, 14));
 
         this.densityGeneratorMap.put(Biomes.NETHER_NETHER, this::generateDensityMapBiomeNether);
         this.densityGeneratorMap.put(Biomes.NETHER_VOLCANIC_ISLANDS, this::generateDensityMapBiomeNether);
@@ -230,7 +227,7 @@ public class DensityGeneratorNether
         double[] minLimitArray = this.minLimitNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
         double[] maxLimitArray = this.maxLimitNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
 
-        double[] ravineNoise = this.ravineNoise2.getRegion(null, x, z, xSize, zSize, ravineNoiseScale, ravineNoiseScale, 3.0D, 3.0D);
+        double[] ravineNoise = this.ravineNoise2.setLacunarity(3.0).setPersistence(3.0).getRegion(null, x, z, xSize, zSize, ravineNoiseScale, ravineNoiseScale);
 //        double[] ravineMod = ravineNoise2.getValue(null, x, z, xSize, zSize, ravineNoiseScale, ravineNoiseScale, 0.25D, 0.6D);
 
         int mainIndex = 0;
@@ -356,7 +353,7 @@ public class DensityGeneratorNether
         double[] mainNoiseArray = this.mainNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale / mainNoiseScaleX, heightScale / mainNoiseScaleY, coordScale / mainNoiseScaleZ);
         double[] minLimitArray = this.minLimitNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
         double[] maxLimitArray = this.maxLimitNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
-        double[] islandNoiseArray = this.islandNoise.getRegion(null, x, z, xSize, zSize, noiseScale, noiseScale, 2, 2);
+        double[] islandNoiseArray = this.islandNoise.setLacunarity(2.0).setPersistence(2.0).getRegion(null, x, z, xSize, zSize, noiseScale, noiseScale);
 
         int mainIndex = 0;
 
@@ -576,8 +573,8 @@ public class DensityGeneratorNether
         double[] mainNoiseArray = this.mainNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale / mainNoiseScaleX, heightScale / mainNoiseScaleY, coordScale / mainNoiseScaleZ);
         double[] minLimitArray = this.minLimitNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
         double[] maxLimitArray = this.maxLimitNoise.getRegion(null, x, y, z, xSize, ySize, zSize, coordScale, heightScale, coordScale);
-        double[] poolOverArray = this.poolNoiseOver.getRegion(null, x, z, xSize, zSize, poolNoiseScale, poolNoiseScale, 1, 0.2);
-        double[] poolUnderArray = this.poolNoiseUnder.getRegion(null, x, z, xSize, zSize, poolNoiseScale, poolNoiseScale, 0.01, 1);
+        double[] poolOverArray = this.poolNoiseOver.setLacunarity(1.0).setPersistence(0.2).getRegion(null, x, z, xSize, zSize, poolNoiseScale, poolNoiseScale);
+        double[] poolUnderArray = this.poolNoiseUnder.setLacunarity(0.01).setPersistence(1.0).getRegion(null, x, z, xSize, zSize, poolNoiseScale, poolNoiseScale);
         int mainIndex = 0;
 
         int depthScaleIndex = 0;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
index 945bdef32..39d364b46 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
@@ -7,7 +7,8 @@ import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
 import net.minecraft.core.world.generate.chunk.perlin.SurfaceGenerator;
-import net.minecraft.core.world.noise.PerlinNoise;
+import net.minecraft.core.world.noise.FractalNoise3D;
+import net.minecraft.core.world.noise.ImprovedPerlinNoise;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
@@ -16,14 +17,14 @@ public class SurfaceGeneratorNether
     implements SurfaceGenerator {
     private final @NotNull World world;
 
-    private final @NotNull PerlinNoise beachNoise;
-    private final @NotNull PerlinNoise soilNoise;
+    private final @NotNull FractalNoise3D<ImprovedPerlinNoise> beachNoise;
+    private final @NotNull FractalNoise3D<ImprovedPerlinNoise> soilNoise;
 
     public SurfaceGeneratorNether(@NotNull World world) {
         this.world = world;
 
-        this.beachNoise = new PerlinNoise(world.getRandomSeed(), 4, 40);
-        this.soilNoise = new PerlinNoise(world.getRandomSeed(), 4, 44);
+        this.beachNoise = new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 4, 40));
+        this.soilNoise = new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(world.getRandomSeed(), 4, 44));
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
index 559c013c1..616e14710 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
@@ -10,7 +10,9 @@ import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkSection;
 import net.minecraft.core.world.generate.chunk.perlin.DensityGenerator;
 import net.minecraft.core.world.generate.chunk.perlin.TerrainGeneratorLerp;
-import net.minecraft.core.world.noise.PerlinNoise;
+import net.minecraft.core.world.noise.FractalNoise3D;
+import net.minecraft.core.world.noise.ImprovedPerlinNoise;
+import net.minecraft.core.world.noise.Noise3D;
 import net.minecraft.core.world.type.WorldType;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -29,7 +31,7 @@ public class TerrainGeneratorNether
     private final Object2IntMap<Biome> fluidLookup = new Object2IntArrayMap<>();
     private int lastChunkX = Integer.MIN_VALUE;
     private int lastChunkZ = Integer.MIN_VALUE;
-    private final @NotNull PerlinNoise noise = new PerlinNoise(0L, 4, 0);
+    private final @NotNull Noise3D noise = new FractalNoise3D<>(ImprovedPerlinNoise.genOctaves(0L, 4, 0));
     private final double @NotNull [] cache = new double[Chunk.CHUNK_SIZE_X * Chunk.CHUNK_SIZE_Z * (Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y)];
 
     public TerrainGeneratorNether(@NotNull World world) {
